unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, CheckLst, Grids, IniFiles, XPMan;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Panel1: TPanel;
    Timer1: TTimer;
    Button7: TButton;
    StringGrid1: TStringGrid;
    Button9: TButton;
    Button8: TButton;
    Button10: TButton;
    XPManifest1: TXPManifest;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure StringGrid1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Week:array [1..7] of string;
  PlayStop:array [0..6, 1..256] of bool;

implementation

uses
  AIMP_SDK;

{$R *.dfm}

procedure SendMessage2AIMP(ACommand: Integer);
var
  H: HWND;
begin
  H := FindWindow(AIMP2_RemoteClass, AIMP2_RemoteClass);
  if H = 0 then
    ShowMessage('AIMP is not found!')
  else
    SendMessage(H, WM_AIMP_COMMAND, WM_AIMP_CALLFUNC, ACommand);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  SendMessage2AIMP(AIMP_PREV);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  SendMessage2AIMP(AIMP_PLAY);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  SendMessage2AIMP(AIMP_PAUSE);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  SendMessage2AIMP(AIMP_STOP);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  SendMessage2AIMP(AIMP_NEXT);
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  H: HWND;
  S: string;
begin
  H := FindWindow(AIMP2_RemoteClass, AIMP2_RemoteClass);
  if H = 0 then
    ShowMessage('AIMP is not found!')
  else
    begin
      case SendMessage(H, WM_AIMP_COMMAND, WM_AIMP_STATUS_GET, AIMP_STS_Player) of
        0: S := 'Stopped';
        1: S := 'Playing';
        2: S := 'Paused';
      end;
      Panel1.Caption := Format('%s, %d/%d sec', [S, 
        SendMessage(H, WM_AIMP_COMMAND, WM_AIMP_STATUS_GET, AIMP_STS_POS),
        SendMessage(H, WM_AIMP_COMMAND, WM_AIMP_STATUS_GET, AIMP_STS_LENGTH)]);
    end;
end;

procedure TForm1.Button7Click(Sender: TObject);
var
AlarmCount:byte;
begin
  AlarmCount:=StringGrid1.RowCount-1;
  StringGrid1.RowCount:=StringGrid1.RowCount+1;
  if StringGrid1.RowCount>5 then
  begin
    StringGrid1.Width:=458+GetSystemMetrics(SM_CXVSCROLL);
    Form1.Width:=467+GetSystemMetrics(SM_CXVSCROLL);
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
var
  IniFile : TIniFile;
  i,j:byte;
  s:string;
begin
  week[1]:='';
  week[2]:='';
  week[3]:='';
  week[4]:='';
  week[5]:='';
  week[6]:='';
  week[7]:='';
  Stringgrid1.Cells[0,0]:='.';
  Stringgrid1.Cells[1,0]:='.';
  Stringgrid1.Cells[2,0]:='.';
  Stringgrid1.Cells[3,0]:='.';
  Stringgrid1.Cells[4,0]:='.';
  Stringgrid1.Cells[5,0]:='.';
  Stringgrid1.Cells[6,0]:='.';
  if fileexists(ExtractFilePath(Application.ExeName)+'AimpAlarms.ini') then
  begin
    IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName)+'AimpAlarms.ini');
    StringGrid1.RowCount:=strtoint(IniFile.ReadString('Options','AlarmsCount',''))+1;
    for i:=0 to 6 do
    begin
      for j:=1 to StringGrid1.RowCount-1 do
      begin
      s:=IniFile.ReadString(inttostr(i),inttostr(j),'');
      Stringgrid1.Cells[i,j]:=s;
      PlayStop[i,j]:=strtobool(IniFile.ReadString(inttostr(i),inttostr(j)+'PlayStop','1'));
      end;
    end;
    if StringGrid1.RowCount>5 then StringGrid1.Width:=StringGrid1.Width+GetSystemMetrics(SM_CXVSCROLL);
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
CurrDayNumber,i,j:byte;
begin
  CurrDayNumber:=DayOfWeek(Date);
  Form1.Caption:='AimpAlarms by Sorokin A.V. - '+week[CurrDayNumber]+', '+TimeToStr(SysUtils.Time);
  i:=CurrDayNumber-2;
  if CurrDayNumber=1 then i:=6;
  for j:=1 to Stringgrid1.RowCount do
  begin
    if ((Stringgrid1.Cells[i,j]=TimeToStr(SysUtils.Time)) and (PlayStop[i,j] = true)) then SendMessage2AIMP(AIMP_PLAY);
    if ((Stringgrid1.Cells[i,j]=TimeToStr(SysUtils.Time)) and (PlayStop[i,j] = false)) then SendMessage2AIMP(AIMP_STOP);
  end;
end;                       


procedure TForm1.Button9Click(Sender: TObject);
var
IniFile : TIniFile;
i,j:byte;
begin
  IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName)+'AimpAlarms.ini');
  IniFile.WriteString('Options','AlarmsCount',inttostr(StringGrid1.RowCount-1));
  for i:=0 to 6 do
  begin
    for j:=1 to StringGrid1.RowCount-1 do
    begin
    IniFile.WriteString(inttostr(i),inttostr(j),Stringgrid1.Cells[i,j]);
    IniFile.WriteString(inttostr(i),inttostr(j)+'PlayStop',booltostr(PlayStop[i,j]));
    end;
  end;
end;

procedure TForm1.Button8Click(Sender: TObject);
var
i,j:byte;
begin
  if StringGrid1.RowCount>2 then
  begin
    for i:=0 to 6 do
    begin
     for j:=StringGrid1.Row to StringGrid1.RowCount do
     begin
     StringGrid1.Cells[i,j]:=StringGrid1.Cells[i,j+1];
     PlayStop[i,j]:=PlayStop[i,j+1];
     PlayStop[i,StringGrid1.RowCount]:=false;
     end;
    end;
    StringGrid1.RowCount:=StringGrid1.RowCount-1;
  end;
  if StringGrid1.RowCount<6 then
  begin
    StringGrid1.Width:=458;
    Form1.Width:=467;
  end;
end;

procedure TForm1.Button10Click(Sender: TObject);
var
  IniFile : TIniFile;
  i,j:byte;
  s:string;
begin
  IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName)+'AimpAlarms.ini');
  StringGrid1.RowCount:=strtoint(IniFile.ReadString('Options','AlarmsCount',''))+1;
  for i:=0 to 6 do
  begin
    for j:=1 to StringGrid1.RowCount-1 do
    begin
    s:=IniFile.ReadString(inttostr(i),inttostr(j),'');
    Stringgrid1.Cells[i,j]:=s;
    PlayStop[i,j]:=strtobool(IniFile.ReadString(inttostr(i),inttostr(j)+'PlayStop','1'));
    CheckBox1.Checked:=PlayStop[StringGrid1.Col,StringGrid1.Row];
    end;
  end;
end;

procedure TForm1.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
const //   .       .
  clPaleGreen = TColor($CCFFCC);
  clPaleRed = TColor($CCCCFF);
var
i,j:byte;
begin
  //   ,       
  if ARow>0 then
  begin
    if PlayStop[ACol,ARow]=true then
    begin
      StringGrid1.Canvas.Brush.color := clPaleGreen;
    end
    else
    begin
      StringGrid1.canvas.brush.Color := clPaleRed;
    end;
  StringGrid1.Canvas.Font.Color := clBlack;
  end;

  if (gdFocused in State) then
  begin
    StringGrid1.Canvas.Brush.Color := clBlue;
    StringGrid1.Canvas.Font.Color := clWhite;
  end;
  StringGrid1.Canvas.FillRect(Rect);
  StringGrid1.Canvas.TextOut(Rect.Left, Rect.Top, StringGrid1.Cells[ACol, ARow]);
end;

procedure TForm1.StringGrid1Click(Sender: TObject);
begin
CheckBox1.Checked:=PlayStop[StringGrid1.Col,StringGrid1.Row];
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
PlayStop[StringGrid1.Col,StringGrid1.Row]:=CheckBox1.Checked;
end;

end.
